﻿using System;
using System.Configuration;
using System.Collections.Generic;
using System.Collections;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using BitFactory.Logging;
using ClusterMaxDAL;
using System.Management.Automation;
using System.Management.Automation.Runspaces;
using System.IO;
using System.Xml;
using System.Text.RegularExpressions;
using System.Net;

namespace CloudResourceManager
{
    public class TemplateManager
    {
        Dictionary<String, String> internalTable = null;

        private void InitializeInternalTable()
        {
            internalTable = new Dictionary<string,string>();
            internalTable.Add("frame", "15");
            internalTable.Add("file", "production/scenes/03_apple/03.blend");
            internalTable.Add("task", "1188");
            internalTable.Add("formatExtName", "jpg");
            internalTable.Add("format", "JPEG");
            internalTable.Add("job", "29");
            internalTable.Add("user", "nickhuang99");
        }


        public int ReplaceTemplateFileTest(String strFileName, ref Dictionary<String, String> hashTable)
        {
            int nResult = 0;
            String strPattern = @"\$\w+";

            try
            {
                // Create an instance of StreamReader to read from a file.
                // The using statement also closes the StreamReader.
                using (StreamReader sr = new StreamReader(strFileName))
                {
                    String line;
                    // Read and display lines from the file until the end of 
                    // the file is reached.
                    while ((line = sr.ReadLine()) != null)
                    {
                        Console.WriteLine(line);
                        foreach (Match match in Regex.Matches(line, strPattern))
                        {
                            String strKey= match.Groups[0].Value.Substring(1);
                            int nStart = match.Groups[0].Index, nEnd = match.Groups[0].Index + match.Groups[0].Value.Length;
                            Console.WriteLine("token found '{0}' found at position {1} and ends at {2}.", strKey, nStart, nEnd);
                            if (hashTable.ContainsKey(strKey))
                            {
                                Console.WriteLine("{0}={1}", strKey, hashTable[strKey]);
                            }
                            else
                            {
                                Console.WriteLine("you need to find this key '{0}'", strKey);
                            }
                            nResult++;
                        }

                    }
                }
            }
            catch (Exception e)
            {
                // Let the user know what went wrong.
                Console.WriteLine("The file could not be read:");
                Console.WriteLine(e.Message);
            }
            return nResult;
        }
        private String ResolveInternalKey(String strKey)
        {
            String strResult;
            if (internalTable == null)
            {
                InitializeInternalTable();
            }
            if (strKey.CompareTo("frameNumberFormat") == 0)
            {
                int frame = Int32.Parse(internalTable["frame"]);
                strResult = frame.ToString("0000");
            }
            else
            {
                strResult = internalTable[strKey];
            }
            return strResult;
        }


        public int ReplaceTemplateFile(String strTemplateName, String strTargetName, ref Dictionary<String, String> hashTable)
        {
            int nResult = 0;
            String strPattern = @"\$([a-z]|[A-Z]|[0-9])+";

            try
            {
                // Create an instance of StreamReader to read from a file.
                // The using statement also closes the StreamReader.
                using (StreamReader sr = new StreamReader(strTemplateName))
                {
                    using (StreamWriter sw = new StreamWriter(strTargetName))
                    {
                        String line;
                        // Read and display lines from the file until the end of 
                        // the file is reached.
                        while ((line = sr.ReadLine()) != null)
                        {
                            int nCurrent = 0, nLength = 0;
                            
                            //debugging
                            Console.WriteLine(line);
                            foreach (Match match in Regex.Matches(line, strPattern))
                            {
                                String strKey = match.Groups[0].Value.Substring(1), strValue;
                                int nStart = match.Groups[0].Index, nEnd = match.Groups[0].Index + match.Groups[0].Value.Length;
                                //Console.WriteLine("token found '{0}' found at position {1} and ends at {2}.", strKey, nStart, nEnd);
                                if (hashTable.ContainsKey(strKey))
                                {
                                    strValue = hashTable[strKey];                                    
                                }
                                else
                                {
                                    //Console.WriteLine("you need to find this key '{0}'", strKey);
                                    //strValue = strKey + "_value";
                                    strValue = ResolveInternalKey(strKey);
                                }
                                //debugging
                                //Console.WriteLine("{0}={1}", strKey, strValue);
                                // before write key/replacement, we need to copy possible skipped part of line
                                nLength = nStart - nCurrent;
                                if (nLength > 0)
                                {
                                    sw.Write(line.Substring(nCurrent, nLength));
                                    // debugging
                                    Console.Write(line.Substring(nCurrent, nLength));
                                    nCurrent += nLength;
                                }
                                // let write the replaced value at position of key
                                sw.Write(strValue);
                                Console.Write(strValue);
                                nCurrent = nEnd;
                                nResult++;
                            }

                            //write the rest of part of line
                            if (nCurrent < line.Length)
                            {
                                sw.Write(line.Substring(nCurrent, line.Length - nCurrent));
                                Console.Write(line.Substring(nCurrent, line.Length - nCurrent));
                            }
                            sw.WriteLine("");
                            Console.WriteLine("");
                        }
                    }
                }
            }
            catch (Exception e)
            {
                // Let the user know what went wrong.
                Console.WriteLine("The file could not be read:");
                Console.WriteLine(e.Message);
            }
            return nResult;
        }


        public int ReplaceTemplateFileTest(String strFileName)
        {
            int nResult = 0;
            String strPattern = @"\$\w+";

            try
            {
                // Create an instance of StreamReader to read from a file.
                // The using statement also closes the StreamReader.
                using (StreamReader sr = new StreamReader(strFileName))
                {
                    String line;
                    // Read and display lines from the file until the end of 
                    // the file is reached.
                    while ((line = sr.ReadLine()) != null)
                    {
                        Console.WriteLine(line);
                        foreach (Match match in Regex.Matches(line, strPattern))
                        {
                            Console.WriteLine("token found '{0}' found at position {1} and ends at {2}.", match.Groups[0].Value, match.Groups[0].Index, match.Groups[0].Index + match.Groups[0].Value.Length);
                            nResult++;
                        }

                    }
                }
            }
            catch (Exception e)
            {
                // Let the user know what went wrong.
                Console.WriteLine("The file could not be read:");
                Console.WriteLine(e.Message);
            }
            return nResult;
        }

    }
}